using System;
using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void DirectoryCreate(SqlString path)
    {
        Int16 errSeverity = 16;

        try
        {
            // Determine whether the directory exists.
            if (Directory.Exists(path.ToString()) == false)
            {
                // Try to create the directory.
                DirectoryInfo di = Directory.CreateDirectory(path.ToString());
            }
            else
            {
                // Generate informational message that the directory did not exist.
                errSeverity = 10;
                Exception newEx = new Exception("Directory already exists.");
                throw newEx;
            }
        }
        catch (Exception ex)
        {
            // Connect to server in event of error
            SqlConnection conn = new SqlConnection("context connection=true");
            conn.Open();

            // Generate error response to SQL Server
            string msg = string.Format("RAISERROR('{0}',{1},1)", ex.Message.Replace('\'', ' '), errSeverity);
            SqlCommand cmd = new SqlCommand(msg, conn);

            try
            {
                // Execute error on SQL Server
                SqlPipe sqlpipe = SqlContext.Pipe;
                sqlpipe.ExecuteAndSend(cmd);
                Exception newEx = new Exception(msg);
                throw newEx;
            }
            catch { } // Prevent error duplication
        }
    }
};
